priv.mcq.is.trully.anova.object = function (object) {
	if ((class(object) == "mcq.protquantity.anova") || (class(object) == "mcq.peakcounting.anova") || (class(object) == "mcq.spectralcounting.anova")) {
		return (TRUE)
	}
	return (FALSE)
}

priv.mcq.is.anova.object = function (object) {
	if ((class(object) == "mcq.protquantity.anova") || (class(object) == "mcq.peakcounting.anova") || (class(object) == "mcq.spectralcounting.anova")
			|| (class(object) == "mcq.peakcounting.kruskal") || (class(object) == "mcq.spectralcounting.kruskal")) {
		return (TRUE)
	}
	return (FALSE)
}

priv.mcq.anova = function (object, factorList, kruskal=F, Tukey=c(), alpha = 0.05) {

	if (is.vector(factorList)) {

	}
	else {
		factorList <- c(factorList)
	}

	if (is.vector(Tukey)) {

	}
	else {
		Tukey <- c(Tukey)
	}

	if (kruskal) {
		if (length(factorList) > 1) {
			stop(paste("Kruskal test is only available for one factor"))
		}
		cat("performing Kruskal test\n")
	}
	protval <- object@protval
	if (class(object) == "mcq.protquantity") {
		newObject <- new ("mcq.protquantity.anova", protval =  object@protval , metadata =  object@metadata, proteins = object@proteins, samples = object@samples, paramlist= list(), resultanov = data.frame(), resulttukey=list())
	} else if (class(object) == "mcq.spectralcounting") {
		if (kruskal) {
			newObject <- new ("mcq.spectralcounting.kruskal", protval =  object@protval , metadata =  object@metadata, proteins = object@proteins, samples = object@samples, paramlist= list(), resultanov = data.frame(), resulttukey=list())
		} else {
			newObject <- new ("mcq.spectralcounting.anova", protval =  object@protval , metadata =  object@metadata, proteins = object@proteins, samples = object@samples, paramlist= list(), resultanov = data.frame(), resulttukey=list())
		}
	} else if (class(object) == "mcq.peakcounting") {
		if (kruskal) {
			newObject <- new ("mcq.peakcounting.kruskal", protval =  object@protval , metadata =  object@metadata, proteins = object@proteins, samples = object@samples, paramlist= list(), resultanov = data.frame(), resulttukey=list())
		} else {
			newObject <- new ("mcq.peakcounting.anova", protval =  object@protval , metadata =  object@metadata, proteins = object@proteins, samples = object@samples, paramlist= list(), resultanov = data.frame(), resulttukey=list())
		}
	}

	newObject@paramlist$kruskal <- kruskal
	newObject@paramlist$factorList <- factorList
	newObject@paramlist$factorListTuckey <- Tukey
	newObject@paramlist$interactionList <- c()
	if (length(factorList) == 2) {
		newObject@paramlist$interactionList <- c(paste(factorList, collapse="__"))
	}
	if (length(factorList) == 3) {
		newObject@paramlist$interactionList <- c(paste(factorList[c(1,2)], collapse="__"),
				paste(factorList[c(1,3)], collapse="__"),
				paste(factorList[c(2,3)], collapse="__"),
				paste(factorList, collapse="__"))
	}
	if (length(factorList) > 3) {
		stop(paste("too much factors in your factor list"))
	}

	for (factorName in factorList) {
		if (factorName %in% colnames(newObject@metadata@metadata)) {

		}
		else {
			stop(paste("the factor ",factorName," is not described in your metadata"))
		}
	}

	options(contrasts=c("contr.sum","contr.sum"))
	tabLevels <- unique(as.character(protval$protein))
	nbprot<- length(tabLevels)
	ni <- protval[,c("msrun", "protein", "q")]
	ni <- merge (ni, newObject@metadata@metadata, by.x="msrun", by.y="row.names")
	newObject@resultanov<- data.frame()
	resulttukey <- list()
	resultaov <- list()
	#print (tabLevels)
	#names(newObject@resulttukey) <- tabLevels

	matrixAnov <- NULL
	for (ip in 1:nbprot){
		myprot <- tabLevels[ip]
		tabcour <- ni[ni$protein==myprot,]

		if (kruskal) {
			ktest <- kruskal.test(as.formula(paste("q~",paste(factorList, collapse='*'),sep="")), data = tabcour)
			resultByFactor <- c(ktest$p.value)
			names(resultByFactor) <- factorList[1]
#print (ktest$p.value)
		}
		else {
			#lm.prot<-lm(paste("q~",paste(factorList, collapse='*'),sep=""), data=tabcour)
			resultaov[myprot]<-list(aov(as.formula(paste("q~",paste(factorList, collapse='*'),sep="")), data=tabcour))

			if (length(Tukey) > 0) {
				#agricolae Tukey :
				#tuktest=HSD.test(lm.prot, alpha=alpha,Tukey, group=TRUE)
				#standard library :
				tuktest=TukeyHSD(resultaov[[myprot]],Tukey, conf.level=1-alpha, ordered=TRUE)
				resulttukey[myprot] <- list(tuktest)
			}
#tuktest=HSD.test(lm.prot, alpha=0.05,factorList, group=TRUE )
#newObject@resulttukey<-rbind(newObject@resulttukey,cbind.data.frame(Protein=rep(myprot, nrow(tuktest$groups)),tuktest$groups))

			resultByFactor <- c()
			ifactor <- 0
			for (factorName in factorList) {
				ifactor <- ifactor+1
				resultByFactor[factorName]<-anova(resultaov[[myprot]])["Pr(>F)"][[1]][ifactor]
			}
			if (sum(is.na(resultByFactor)) == length(factorList)) {
				for (factorName in factorList) {
					resultByFactor[factorName] <- NA
				}
				for (factorName in newObject@paramlist$interactionList) {
					resultByFactor[factorName] <- NA
				}
			}
			else {
				for (factorName in newObject@paramlist$interactionList) {
					ifactor <- ifactor+1
					resultByFactor[factorName]<-anova(resultaov[[myprot]])["Pr(>F)"][[1]][ifactor]
				}
			}
		}
		if (is.null(matrixAnov)) {
			matrixAnov <- matrix (resultByFactor, ncol=length(resultByFactor), nrow=nbprot)
		}
		else {
			matrixAnov[ip,]<-resultByFactor
		}
		#rownames(matrixAnov)[ip] <- myprot
#print (matrixAnov)

		if (ip%%10==0) cat(paste(ip," proteins\n"))
	}
	newObject@resulttukey <- resulttukey

	if (priv.mcq.is.trully.anova.object(newObject)) {
		newObject@aov <- resultaov
	}
	newObject@resultanov <- data.frame(matrixAnov)
	rownames(newObject@resultanov) <- tabLevels

	#newObject@resultanov$Protein <- NULL
	#rename column :
	colnames(newObject@resultanov) <- names (resultByFactor)

#head (newObject@resultanov)


	return (newObject)
}

priv.mcq.plot.anova = function (object,pdf=NULL) {
	if (is.null(object@resultanov)) {
		stop("there is no anova results in your object")
	}

	#object@paramlist$pvaluethreshold
	#object@paramlist$mindiffpeak
	#object@paramlist$factorsignif

	if (is.null(object@paramlist$factorsignif)) {
		stop("mcqPlotProteinAnova only works after mcqSelectProteinAnovaSignif")
	}

	tabprot <- object@protval
	listprot <- unique(object@protval$protein)
	factorName <- object@paramlist$factorsignif

	cat(paste("The factor \"", factorName,"\" was used to select proteins significantly different\n", sep=""))

	cat(paste(length(listprot)," proteins significantly different between extrem levels of factor \"",factorName,  "\"\n", sep=""))

	if (is.null(pdf)){
		par(ask=TRUE)
	}
	else{
		pdf(pdf, title=gsub('.pdf$','',pdf))
	}

	tabprot <- merge(object@protval, object@metadata@metadata, by.x="msrun", by.y="row.names")

	for (protein_code in listprot) {
		tabcour=tabprot[tabprot$protein==protein_code,]
		protein_name <- object@proteins[protein_code, "accession"]
		#title <- paste(protein_name, " (", factorName, ")", sep="")
		#visuprot(protein_code,tabcour,tabcour$q,tabcour[,factorName], title=title)
		visuprot(protein_code,tabcour,tabcour$q,tabcour[,factorName], title=protein_name)
	}



	if (!is.null(pdf)){
		dev.off()
	}

}


#priv.check.anova.factor <-function (object, fdr, factor=NULL) {
priv.check.anova.factor <-function (object, factor=NULL) {
	if (is.null(object@resultanov)) {
		stop("there is no anova results in your object")
	}
	if (nrow(object@resultanov) == 0) {
		stop("there is no anova results in your object")
	}
	## Sélection des protéines présentant une différence minimale entre les deux traitements les plus extrèmes.
	ni <- object@protval
	ni <- merge (ni, object@metadata@metadata, by.x="msrun", by.y="row.names")
	factorName <- factor
	factorList <- colnames(object@metadata@metadata)
	if (is.null(factorName)) {
		if (length(factorList) > 1) {
			stop(paste("You must choose a factor to select significantly different proteins (add the parameter factor=).\n",
							"available factors are : ", paste(factorList,collapse=", "), "\n", sep=""))
		}
		factorName <- factorList[1]
	}
#print(factorName)
	if (factorName %in% colnames(object@metadata@metadata)) {
	}
	else {
		stop(paste("the factor ",factorName," is not described in your metadata", sep=""))
	}
	if (factorName %in% colnames(object@resultanov)) {
	}
	else {
		stop(paste("the factor ",factorName," is not described in the results of the anova", sep=""))
	}
	return (factorName)
}

priv.anova.select.signif <-function (object, ok.signif) {

#metadata="mcqMetadata", count="data.frame", resultanov="data.frame", paramlist
	nbProt = length(ok.signif)
	object@resultanov$bidonnage <- object@resultanov[,1]
	object@resultanov <- object@resultanov[ok.signif,]
	object@resultanov$bidonnage <- NULL
	object@resultanov <- drop.levels(object@resultanov)
	newNbProt <- length(rownames(object@resultanov))

	cat (paste(newNbProt," proteins selected. ", (nbProt - newNbProt), " proteins dropped\n", sep=""))

#"protein msrun count"
#cleaning object slots
	object@protval <- object@protval[object@protval$protein %in% rownames(object@resultanov),]
	object@protval <- drop.levels(object@protval)

	msrunlist <- unique(object@protval$msrun)
	object@metadata@metadata$bidon <- rownames(object@metadata@metadata)
	object@metadata@metadata <- object@metadata@metadata[msrunlist,]
	object@metadata@metadata$bidon <- NULL
	object@metadata@metadata <- drop.levels(object@metadata@metadata)

#proteins="data.frame"
	object@proteins <- object@proteins[rownames(object@resultanov),]
	object@proteins <- drop.levels(object@proteins)

#samples
	object@samples$bidonnage <-rownames(object@samples)
	object@samples <- object@samples[msrunlist,]
	object@samples$bidonnage <- NULL
	object@samples <- drop.levels(object@samples)

#resulttukey
	object@resulttukey <- object@resulttukey[ok.signif]

	return (object)
}


priv.mcq.select.anova.signif.fdr <-function (object, fdr, factor) {
	factorName <- priv.check.anova.factor(object, factor);

	#cat (factorName)

	object@paramlist$fdrthreshold <- fdr
	#object@paramlist$mindiffpeak <- mindiff
	object@paramlist$factorsignif <- factorName


	pval.adjusted.fdr <- p.adjust(object@resultanov[,factorName],method="fdr")
	ok.signif <- pval.adjusted.fdr<fdr

	return (priv.anova.select.signif (object, ok.signif))

}

priv.mcq.select.anova.signif <-function (object, pvalue, factor) {

	factorName <- priv.check.anova.factor(object, factor);
	object@paramlist$pvaluethreshold <- pvalue
	#object@paramlist$mindiffpeak <- mindiff
	object@paramlist$factorsignif <- factorName


	ok.signif <- (!is.na(object@resultanov[,factorName])) & (object@resultanov[,factorName]<pvalue)

	return (priv.anova.select.signif (object, ok.signif))
}



mcq.select.anova.signif <-function (object, pvalue, factor=NULL) {
	if (priv.mcq.is.anova.object(object)) {
		print(factor)
		return (priv.mcq.select.anova.signif(object, pvalue, factor))
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.select.anova.signif",sep=""))
	}
}

mcq.select.anova.signif.fdr <-function (object, pvalue, factor=NULL) {
	if (priv.mcq.is.anova.object(object)) {

		return (priv.mcq.select.anova.signif.fdr(object, pvalue, factor))
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.select.anova.signif.fdr",sep=""))
	}

}


mcq.plot.anova  <- function (object, pdf=NULL) {
	if (priv.mcq.is.anova.object(object)) {
		return (priv.mcq.plot.anova(object, pdf))
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.plot.anova",sep=""))
	}

}

mcq.anova = function (object, factorList, Tukey=c(), alpha=0.05) {
	if (priv.mcq.is.protquant.object(object)) {
		return (priv.mcq.anova(object, factorList, kruskal=F, Tukey=Tukey, alpha=alpha))
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.anova",sep=""))
	}
}
