
mcq.get.cv = function (object, factor=NULL) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline") || priv.mcq.is.protquant.object(object)) {
		if (is.null(factor)) {
			stop(paste("Please define a factore to select replicate\n",
							"available factors are : ", paste(colnames(object@metadata@metadata),collapse=", "), sep=""))
		}
		if (factor %in% colnames(object@metadata@metadata)) {
		}
		else {
			stop(paste("the factor ",factor," is not described in your metadata\n",
							"available factors are : ", paste(colnames(object@metadata@metadata),collapse=", "), sep=""))
		}
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.get.cv",sep=""))
	}

	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		tpep <- merge(object@peptides[, c("msrun", "area", "peptiz")], object@metadata@metadata, by.x="msrun", by.y="row.names")

		peptidgroup=as.factor(paste(tpep$peptiz,tpep[, factor],sep='--'))
		## Suppression des peptiz dont l'écart-type du temps de rétention est trop élevé
		sdpep=aggregate(tpep$area,list(peptidgroup),FUN=sd)
		meanpep=aggregate(tpep$area,list(peptidgroup),FUN=mean)
		result = data.frame(sd = sdpep[,2], mean = meanpep[,2])
		row.names(result) = sdpep[,1]
		result$cv = 100 *result$sd /result$mean
		result[, factor] = as.character(lapply(strsplit(as.character(row.names(result)), split="--"), "[", 2))
		result[, factor] = as.factor(result[, factor])
		return (result);
	} else if (priv.mcq.is.protquant.object(object)) {
		tpep <- merge(object@protval[, c("protein", "msrun", "q")], object@metadata@metadata, by.x="msrun", by.y="row.names")

		tpep$qnolog = 10^tpep$q
		peptidgroup=as.factor(paste(tpep$protein,tpep[, factor],sep='--'))
		## Suppression des peptiz dont l'écart-type du temps de rétention est trop élevé
		sdpep=aggregate(tpep$qnolog,list(peptidgroup),FUN=sd)
		meanpep=aggregate(tpep$qnolog,list(peptidgroup),FUN=mean)
		result = data.frame(sd = sdpep[,2], mean = meanpep[,2])
		row.names(result) = sdpep[,1]
		result$cv = 100 *result$sd /result$mean
		result[, factor] = as.character(lapply(strsplit(as.character(row.names(result)), split="--"), "[", 2))
		result[, factor] = as.factor(result[, factor])
		return (result);
	}
}