
mcq.drop <-function (object, factor, levels) {
	if (is.null(levels)) {
		stop(paste("not implemented",sep=""))
	} else {
		if (is.vector(levels)) {

		}
		else {
			levels <- c(levels);
		}
	}

	if (class(object) == "mcqProtPep") {
		peptide_col_names = c("group","mz" ,"rt","maxintensity","area","rtbegin","rtend","peptide","isotope","sequence","z","mods", "nilevel", "nirank", "niratio")
		nbpeptides <- length(unique(object@peptides$peptide))
		nbprot <- length(unique(object@proteins$protein))

		if(factor == "msrun") {
			object@peptides <- object@peptides[!(object@peptides$msrun %in% levels),]
			object@peptides <- drop.levels(object@peptides)

			object@proteins <- object@proteins[object@proteins$peptide %in% object@peptides$peptide,]
			object@proteins <- drop.levels(object@proteins)

			object@metadata@metadata$bidon <- rownames(object@metadata@metadata)
			object@metadata@metadata <- object@metadata@metadata[!(rownames(object@metadata@metadata) %in% levels),]
			object@metadata@metadata$bidon <- NULL
			object@metadata@metadata <- drop.levels(object@metadata@metadata)

			object@metadata@samples$bidon <- rownames(object@metadata@samples)
			object@metadata@samples <- object@metadata@samples[!(rownames(object@metadata@samples) %in% levels),]
			object@metadata@samples$bidon <- NULL
			object@metadata@samples <- drop.levels(object@metadata@samples)

		} else if (factor %in% peptide_col_names) {
			# delete some peptides using a column of peptides dataframe
			#in colnames "group","msrun","msrunfile","mz" ,"rt"   ,        "maxintensity", "area"    ,     "rtbegin"    ,
			#"rtend"      ,  "peptide"   ,   "isotope"    ,  "sequence"  ,   "z"         ,   "mods"
			cat (paste("drop on ", factor, " column in the peptides dataframe\n", sep=""))
			peptide_ok <- !(object@peptides[,factor]  %in% levels)

			object@peptides <- object@peptides[peptide_ok,]
			object@peptides <- drop.levels(object@peptides)

			cat (paste("cleaning proteins\n", sep=""))
			object@proteins <- object@proteins[object@proteins$peptide %in% object@peptides$peptide,]
			object@proteins <- drop.levels(object@proteins)

			if (nrow(object@metadata@metadata) > 0){

				cat (paste("cleaning metadata\n", sep=""))
				object@metadata@metadata$bidonnage <- rownames(object@metadata@metadata)
				object@metadata@metadata <- object@metadata@metadata[unique(object@peptides$msrun),]
				object@metadata@metadata$bidonnage <- NULL
				object@metadata@metadata <- drop.levels(object@metadata@metadata)

				cat (paste("cleaning metadata samples\n", sep=""))
				object@metadata@samples$bidon <- rownames(object@metadata@samples)
				object@metadata@samples <- object@metadata@samples[rownames(object@metadata@metadata),]
				object@metadata@samples$bidon <- NULL
				object@metadata@samples <- drop.levels(object@metadata@samples)
			}

		}
		else {
			if (factor %in% colnames(object@metadata@metadata)) {
			}
			else {
				stop(paste("the factor ",factor," is not described in your metadata\n",
								"available factors are : ", paste(colnames(object@metadata@metadata),collapse=", "), sep=""))
			}

			object@metadata@metadata$bidon <- rownames(object@metadata@metadata)
			msrunListToDrop <- rownames(object@metadata@metadata[object@metadata@metadata[,factor] %in% levels,])
			object@metadata@metadata <- object@metadata@metadata[!(rownames(object@metadata@metadata) %in% msrunListToDrop),]
			object@metadata@metadata$bidon <- NULL
			object@metadata@metadata <- drop.levels(object@metadata@metadata)

			object@metadata@samples$bidon <- rownames(object@metadata@samples)
			object@metadata@samples <- object@metadata@samples[!(rownames(object@metadata@samples) %in% msrunListToDrop),]
			object@metadata@samples$bidon <- NULL
			object@metadata@samples <- drop.levels(object@metadata@samples)

			object@peptides <- object@peptides[!(object@peptides$msrun %in% msrunListToDrop),]
			object@peptides <- drop.levels(object@peptides)

			object@proteins <- object@proteins[object@proteins$peptide %in% object@peptides$peptide,]
			object@proteins <- drop.levels(object@proteins)

			#stop(paste("not implemented",sep=""))
		}

		nbpeptidesafter <- length(unique(object@peptides$peptide))
		nbprotafter <- length(unique(object@proteins$protein))
		cat (paste((nbpeptides - nbpeptidesafter), " peptides dropped\n", sep=""))
		cat (paste((nbprot - nbprotafter), " proteins dropped\n", sep=""))
	}
	else if(class(object) == "mcq.spectralcounting") {
		nbsamples <- length(unique(object@samples$msrunfile))
		if(factor == "msrun") {
			object@protval <- object@protval[!(object@protval$msrun %in% levels),]
			object@protval <- drop.levels(object@protval)

			object@proteins <- object@proteins[object@proteins$accession %in% object@protval$protein,]
			object@proteins <- drop.levels(object@proteins)

			object@metadata@metadata$bidon <- rownames(object@metadata@metadata)
			object@metadata@metadata <- object@metadata@metadata[!(rownames(object@metadata@metadata) %in% levels),]
			object@metadata@metadata$bidon <- NULL
			object@metadata@metadata <- drop.levels(object@metadata@metadata)

			object@metadata@samples$bidon <- rownames(object@metadata@samples)
			object@metadata@samples <- object@metadata@samples[!(rownames(object@metadata@samples) %in% levels),]
			object@metadata@samples$bidon <- NULL
			object@metadata@samples <- drop.levels(object@metadata@samples)

			object@samples$bidon <- rownames(object@samples)
			object@samples <- object@samples[!(rownames(object@samples) %in% levels),]
			object@samples$bidon <- NULL
			object@samples <- drop.levels(object@samples)
		}
		else {
			if (factor %in% colnames(object@metadata@metadata)) {
			}
			else {
				stop(paste("the factor ",factor," is not described in your metadata\n",
								"available factors are : ", paste(colnames(object@metadata@metadata),collapse=", "), sep=""))
			}
			object@metadata@metadata$bidon <- rownames(object@metadata@metadata)
			msrunListToDrop <- rownames(object@metadata@metadata[object@metadata@metadata[,factor] %in% levels,])
			object@metadata@metadata <- object@metadata@metadata[!(rownames(object@metadata@metadata) %in% msrunListToDrop),]
			object@metadata@metadata$bidon <- NULL
			object@metadata@metadata <- drop.levels(object@metadata@metadata)

			object@metadata@samples$bidon <- rownames(object@metadata@samples)
			object@metadata@samples <- object@metadata@samples[!(rownames(object@metadata@samples) %in% msrunListToDrop),]
			object@metadata@samples$bidon <- NULL
			object@metadata@samples <- drop.levels(object@metadata@samples)

			object@protval <- object@protval[!(object@protval$msrun %in% msrunListToDrop),]
			object@protval <- drop.levels(object@protval)

			object@proteins <- object@proteins[object@proteins$accession %in% object@protval$protein,]
			object@proteins <- drop.levels(object@proteins)
		}
		nbsamplesafter <- length(unique(object@samples$msrunfile))
		cat (paste((nbsamples - nbsamplesafter), " samples dropped\n", sep=""))
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.drop",sep=""))
	}
	return (object)
}