

mcq.get.compar <-function (object, flist=NULL, na.rm=T, sampleid=T) {

	if (!is.null(flist)) {
		if (is.vector(flist)) {

		}
		else {
			flist <- c(flist);
		}
	}

	if (priv.mcq.is.protquant.object(object)) {
		tab <- object@protval[,c("protein", "msrun","q")]
		tab <- merge (tab, object@proteins, by.x="protein", by.y="row.names")

		#if (is.null(object@metadata@metadata)) {
		if (is.null(flist)) {

			if (sampleid) {
				tab <- tapply(tab$q,list(tab$accession,tab$msrun),FUN=sum,na.rm=na.rm)
			}
			else {
				tab <- merge (tab, object@samples, by.x="msrun", by.y="row.names")
				tab <- tapply(tab$q,list(tab$accession,tab$msrunfile),FUN=sum,na.rm=na.rm)
			}

			if ((class(object) == "mcq.peakcounting")|| (class(object) == "mcq.spectralcounting")) {
				#rename q to count :
				colnames(tab)[colnames(tab) == "q"] <- "count"
			}

			return (as.data.frame(tab))
		}
		else {
			for (factor in flist) {
				if(factor %in% names(object@metadata@metadata)) {
				}else {
					stop(paste("factor ", factor, " is not described in your metadata\n", "available factors are : ", paste(colnames(object@metadata@metadata),collapse=", "), "\n", sep=""))
				}
			}


			object@metadata@metadata$msrun <- rownames(object@metadata@metadata)
			tab <- merge(tab, object@metadata@metadata, by="msrun")

			#tab$regroup <- paste (tab[ , flist], sep="-")
			tab$regroup=tab[,flist[1]]
			if (length(flist)>1){
				for (i in 2:length(flist)){
					tab$regroup = paste(tab$regroup,tab[,flist[i]],sep="-")
				}
			}
			tab <- tapply(tab$q,list(tab$accession,tab$regroup),FUN=mean,na.rm=na.rm)

			if ((class(object) == "mcq.peakcounting")|| (class(object) == "mcq.spectralcounting")) {
				#rename q to count :
				colnames(tab)[colnames(tab) == "q"] <- "count"
			}

			return (as.data.frame(tab))
		}
	}
	else if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")){
		if("lognorm" %in% colnames(object@nona)) {
			tab <- object@nona[,c("peptiz", "msrun","lognorm")]
			colnames(tab)[colnames(tab) == "lognorm"] <- "q"
		}
		else if (is.null(object@peptides$lognorm)) {
			tab <- object@peptides[,c("peptiz", "msrun","logarea")]
			colnames(tab)[colnames(tab) == "logarea"] <- "q"
		}
		else {
			tab <- object@peptides[,c("peptiz", "msrun","lognorm")]
			colnames(tab)[colnames(tab) == "lognorm"] <- "q"
		}
		#tab <- merge (tab, object@proteins, by.x="protein", by.y="row.names")

		if (is.null(flist)) {
			tab <- tapply(tab$q,list(tab$peptiz,tab$msrun),FUN=sum,na.rm=na.rm)
			return (as.data.frame(tab))
		}
		else {
			for (factor in flist) {
				if(factor %in% names(object@metadata@metadata)) {
				}else {
					stop(paste("factor ", factor, " is not described in your metadata\n", "available factors are : ", paste(colnames(object@metadata@metadata),collapse=", "), "\n", sep=""))
				}
			}


			object@metadata@metadata$msrun <- rownames(object@metadata@metadata)
			tab <- merge(tab, object@metadata@metadata, by="msrun")

			#tab$regroup <- paste (tab[ , flist], sep="-")
			tab$regroup=tab[,flist[1]]
			if (length(flist)>1){
				for (i in 2:length(flist)){
					tab$regroup = paste(tab$regroup,tab[,flist[i]],sep="-")
				}
			}
			tab$regroup <- as.factor(tab$regroup)
			tab <- tapply(tab$q,list(tab$peptiz,tab$regroup),FUN=sum,na.rm=na.rm)
			return (as.data.frame(tab))

		}
	}
	else if (priv.mcq.is.anova.object(object)) {
		## export resultat pour tableur
		#dfprotval <- mcqGetDataframe(object)
		#ni.deploye=tapply(dfprotval$q,list(dfprotval$protein,dfprotval$msrunfile),FUN=sum)
		anov <- object@resultanov
		colnames(anov) <- paste("pval_", colnames(anov), sep="")
		anov <- merge(anov, object@proteins, by.x="row.names", by.y="row.names")
		rownames(anov) <-  anov$accession
		anov$accession <- NULL
		anov$descr <- NULL
		anov$Row.names <- NULL
		return (anov)
	}

	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.get.compar",sep=""))
	}
}

mcq.get.merge <- function (protquant.object,decision.stat.object, flist=NULL, na.rm=T, sampleid=T) {
	#priv.mcq.is.protquant.object is in "mcq_compute_protein_value.R" file
	if (priv.mcq.is.protquant.object(protquant.object)) {
		df1 <-mcq.get.compar(protquant.object, flist, na.rm, sampleid=sampleid)
	} else if (class(protquant.object)=="data.frame"){
		df1 = protquant.object
	} else {
		stop(paste("the class \"", class(protquant.object),"\" is not taken into account by mcq.get.merge",sep=""))
	}
	#priv.mcq.is.anova.object is in "mcq_anova.R" file
	if (priv.mcq.is.anova.object(decision.stat.object)) {
		df2 <-mcq.get.compar(decision.stat.object, flist, na.rm, sampleid=sampleid)
	} else if (class(decision.stat.object)=="data.frame"){
		df2 = decision.stat.object
	} else {
		stop(paste("the class \"", class(decision.stat.object),"\" is not taken into account by mcq.get.merge",sep=""))
	}
	#can we make a merge if object1 and object2 has different row numbers ? yes
	#can we make merge if object1 and object2 has different row names ? yes all lines will be reported with NA if they are absent from one of the two objects

	df <- merge(df1,df2,by=0,all=T)
	rownames(df)=df$Row.names
	colnames(df)[1]=""
	return(df)
}

mcq.write.compar.tsv <- function (object, csv, flist=NULL, na.rm=T, sampleid=T) {
	if (is.null(csv)) {
		stop("Please give an output filename")
	}
	df <-mcq.get.compar(object, flist, na.rm, sampleid=sampleid)
	df <- cbind.data.frame(rownamesbidon = rownames(df), df)
	#colnames(df)[colnames(df)=="rownamesbidon"]=""
	colnames(df)[1]=""
	write.table(df,csv, quote= FALSE,  sep="\t", dec=".",row=F)
}

mcq.write.merge.tsv <- function (protquant.object,decision.stat.object, csv, flist=NULL, na.rm=T, sampleid=T) {
	if (is.null(csv)) {
		stop("Please give an output filename")
	}
	df <- mcq.get.merge(protquant.object,decision.stat.object, flist=NULL, na.rm=T, sampleid=sampleid)

	write.table(df,csv, quote= FALSE,  sep="\t", dec=".",row=F)
}

mcq.write.synthesis.tsv <- function (spectral.object,spectral.stat.object,pk.object,pk.stat.object,protquant.object,protquant.stat.object, csv=NULL, na.rm=T,sampleid=T)
{
	if ((class(spectral.object) != "mcq.spectralcounting")) {
		stop(paste("the class of parameter 1 must be mcq.spectralcounting",sep=""))
	}
	if ((class(spectral.stat.object) != "mcq.spectralcounting.kruskal") && (class(spectral.stat.object) != "mcq.spectralcounting.anova") ) {
		stop(paste("the class of parameter 2 must be mcq.spectralcounting.anova or mcq.spectralcounting.kruskal",sep=""))
	}
	if ((class(pk.object) != "mcq.peakcounting")) {
		stop(paste("the class of parameter 3 must be mcq.peakcounting",sep=""))
	}
	if ((class(pk.stat.object) != "mcq.peakcounting.kruskal")&& (class(spectral.stat.object) != "mcq.peakcounting.anova")) {
		stop(paste("the class of parameter 4 must be mcq.peakcounting.anova or mcq.peakcounting.kruskal",sep=""))
	}
	if ((class(protquant.object) != "mcq.protquantity")) {
		stop(paste("the class of parameter 5 must be mcq.protquantity",sep=""))
	}
	if ((class(protquant.stat.object) != "mcq.protquantity.anova")) {
		stop(paste("the class of parameter 6 must be mcq.protquantity.anova",sep=""))
	}
	if (is.null(csv)) {
		stop("Please give an output filename")
	}
	SC=mcq.get.merge(spectral.count,spectral.count.kruskal,flist=NULL, na.rm=T, sampleid=F)
	SC[1]=NULL
	PC=mcq.get.merge(pkcount,pkcount.kruskal,flist=NULL, na.rm=T, sampleid=F)
	PC[1]=NULL
	XIC=mcq.get.merge(qprot,anova, flist=NULL, na.rm=T, sampleid=F)
	XIC[1]=NULL
	temp=mcq.get.merge(SC,PC,flist=NULL, na.rm=T, sampleid=F)
	temp[1]=NULL
	finaltab=mcq.get.merge(temp,XIC,flist=NULL, na.rm=T, sampleid=F)
	mcq.write.merge.tsv(temp,XIC,csv,sampleid=F)
}
