priv.mcq.glm = function (object, factorList, alpha = 0.05) {
	if (is.vector(factorList)) {

	}
	else {
		factorList <- c(factorList)
	}
	protval <- object@protval
	if (class(object) == "mcq.protquantity") {
		newObject <- new ("mcq.protquantity.glm", protval =  object@protval , metadata =  object@metadata, proteins = object@proteins, samples = object@samples, paramlist= list(), resultglm = data.frame())
	} else if (class(object) == "mcq.spectralcounting") {
		newObject <- new ("mcq.spectralcounting.glm", protval =  object@protval , metadata =  object@metadata, proteins = object@proteins, samples = object@samples, paramlist= list(), resultglm = data.frame())
	} else if (class(object) == "mcq.peakcounting") {
		newObject <- new ("mcq.peakcounting.glm", protval =  object@protval , metadata =  object@metadata, proteins = object@proteins, samples = object@samples, paramlist= list(), resultglm = data.frame())
	}

	newObject@paramlist$factorList <- factorList
	newObject@paramlist$interactionList <- c()

	if (length(factorList) == 2) {
		newObject@paramlist$interactionList <- c(paste(factorList, collapse="__"))
	}
	if (length(factorList) == 3) {
		newObject@paramlist$interactionList <- c(paste(factorList[c(1,2)], collapse="__"),
				paste(factorList[c(1,3)], collapse="__"),
				paste(factorList[c(2,3)], collapse="__"),
				paste(factorList, collapse="__"))
	}
	if (length(factorList) > 3) {
		stop(paste("too much factors in your factor list"))
	}

	for (factorName in factorList) {
		if (factorName %in% colnames(newObject@metadata@metadata)) {

		}
		else {
			stop(paste("the factor ",factorName," is not described in your metadata"))
		}
	}

	tabLevels <- unique(as.character(protval$protein))
	nbprot<- length(tabLevels)
	ni <- protval[,c("msrun", "protein", "q")]
	ni <- merge (ni, newObject@metadata@metadata, by.x="msrun", by.y="row.names")
	newObject@resultglm <- data.frame()
	#resultglm <- list()
	matrixGlm <- NULL

	for (ip in 1:nbprot){
		myprot <- tabLevels[ip]
		tabcour <- ni[ni$protein==myprot,]

		tmp <-glm(as.formula(paste("q~",paste(factorList, collapse='*'),sep="")), data=tabcour,family="poisson")
		good.model=with(tmp,cbind(res.deviance=deviance,df=df.residual,p=pchisq(deviance,df.residual,lower.tail=FALSE)))
		proba.good.model=as.vector(good.model[,"p"])

		resultByFactor <- c()
		ifactor <- 1

		resultByFactor["proba.good.model"]<-proba.good.model
		for (factorName in factorList) {
			ifactor <- ifactor+1
			resultByFactor[factorName]<-anova(tmp,test="Chisq")["Pr(>Chi)"][[1]][ifactor]
		}
		for (factorName in newObject@paramlist$interactionList) {
			ifactor <- ifactor+1
			resultByFactor[factorName]<-anova(tmp,test="Chisq")["Pr(>Chi)"][[1]][ifactor]
		}
		if (is.null(matrixGlm)) {
			matrixGlm <- matrix (rep("NA",time=length(resultByFactor)*nbprot), ncol=length(resultByFactor), nrow=nbprot)
			matrixGlm[ip,]<-resultByFactor
		}else{
			matrixGlm[ip,]<-resultByFactor
		}
		if (ip%%10==0) cat(paste(ip," proteins\n"))
		newObject@resultglm <- data.frame(matrixGlm)
		rownames(newObject@resultglm) <- tabLevels
		colnames(newObject@resultglm) <- names (resultByFactor)

		return (newObject)
	}
}
