##################### Identification d une proteine par au moins deux peptides #######################
# dans le cas de facteur a seulement deux modalites
# sinon utiliser la correlation entre peptides de la meme proteine
#
######################################################################################################

mcq.select.2pepbyprot=function(object, minimum.peptides.by.prot=2){
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {

		if (is.numeric(minimum.peptides.by.prot) & (minimum.peptides.by.prot>0)) {

		nbpeptides <- length(unique(object@peptides$peptide))
		nbprot <- length(unique(object@proteins$protein))

		tabcontingence=table(object@proteins$protein,object@proteins$peptide)
		countpep=apply(tabcontingence,MARGIN=1,FUN=sum)
		countpepok=countpep[-which(countpep<minimum.peptides.by.prot)]
		protok=names(countpepok)
		object@proteins=object@proteins[object@proteins$protein %in% protok,]
		object@proteins=drop.levels(object@proteins)
		pepok=levels(object@proteins$peptide)
		object@peptides=object@peptides[object@peptides$peptide %in% pepok,]
		object@peptides=drop.levels(object@peptides)

		nbpeptidesafter <- length(unique(object@peptides$peptide))
		nbprotafter <- length(unique(object@proteins$protein))
		cat (paste((nbpeptides - nbpeptidesafter), " peptides dropped\n", sep=""))
		cat (paste((nbprot - nbprotafter), " proteins dropped (containing less than ",minimum.peptides.by.prot," quantified peptides)\n", sep=""))

		return (object)
	}
	else {
		stop(paste("the argument 'minimum.peptides.by.prot' (", minimum.peptides.by.prot,") MUST be a numeric value greater than 0",sep=""))
	}
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.select.2pepbyprot",sep=""))
	}
}