
mcq.plot.distrib.qlog.diff.ref<- function (object, refSample, pdf=NULL) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		################ normalisation ze
		if (refSample %in% object@peptides$msrun) {

		}
		else {
			stop(paste("the sample named ",refSample," is not in your ",class(object)," object", sep=""))
		}
		nomref=refSample # choisir ici l'échantillon qui servira de référence
		tab.acp<- tapply (object@peptides$logarea, list(object@peptides$peptiz,object@peptides$msrun), FUN=sum)

		#tab.acp => rows = peptiz, cols = msrun, cell = sum of logarea

		ref=which(colnames(tab.acp)==nomref) # ref: numero de la colonne de ref dans tab.acp
		nbech=dim(tab.acp)[2] # 19
		nbpep=dim(tab.acp)[1] # 12697
		matref=matrix(rep(tab.acp[,ref],nbech),ncol=nbech)
		diff=tab.acp-matref

		## visu des distributions avant normalisation
		if (is.null(pdf)){
			par(ask=TRUE)
		}
		else{
			pdf(pdf, title=gsub('.pdf$','',pdf))
		}
		for (i in 1:nbech) {
			if (i !=ref ) {
				hist(diff[,i],nclass=100,main=colnames(tab.acp)[i],xlab=paste("logQ(",colnames(tab.acp)[i],")-logQ(",refSample,")"),xlim=c(-2,2))
			}
		}
		if (!is.null(pdf)){
			dev.off()
		}
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqPlotDistribQlogDiffRef",sep=""))
	}
}

mcq.plot.distrib.qlog<- function (object, pdf=NULL) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		tab.acp<- tapply (object@peptides$logarea, list(object@peptides$peptiz,object@peptides$msrun), FUN=sum)


		nbech=dim(tab.acp)[2] # 19
		nbpep=dim(tab.acp)[1] # 12697

		## visu des distributions avant normalisation
		#pdf("distributions-intensités-avant-normalisation.pdf")
		if (is.null(pdf)){
			par(ask=TRUE)
		}
		else{
			pdf(pdf, title=gsub('.pdf$','',pdf))
		}
		for (i in 1:nbech) {
			#if (i !=ref ) {
			#hist(diff[,i],nclass=100,main=colnames(tab.acp)[i],xlab=paste("logQ(",colnames(tab.acp)[i],")-logQ(",refSample,")"),xlim=c(-2,2))
			hist(tab.acp[,i],nclass=100,main=colnames(tab.acp)[i],xlab=paste("logQ(",colnames(tab.acp)[i],")"))
		}
		if (!is.null(pdf)){
			dev.off()
		}
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqPlotDistribQlog",sep=""))
	}
}


mcq.plot.distrib.qlog.comet.diff<- function (object, refSample, pdf=NULL) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		################ normalisation ze
		if (refSample %in% object@peptides$msrun) {

		}
		else {
			stop(paste("the sample named ",refSample," is not in your mcqProtPep object"))
		}
		nomref=refSample # choisir ici l'échantillon qui servira de référence
		tab.acp<- tapply (object@peptides$logarea, list(object@peptides$peptiz,object@peptides$msrun), FUN=sum)

		#tab.acp => rows = peptiz, cols = msrun, cell = sum of logarea

		ref=which(colnames(tab.acp)==nomref) # ref: numero de la colonne de ref dans tab.acp
		nbech=dim(tab.acp)[2] # 19
		nbpep=dim(tab.acp)[1] # 12697
		matref=matrix(rep(tab.acp[,ref],nbech),ncol=nbech)
		diff=tab.acp-matref

		## visu des distributions avant normalisation
		#pdf("cometes-avant-normalisation.pdf",title="fusées")
		if (is.null(pdf)){
			par(ask=TRUE)
		}
		else{
			pdf(pdf, title=gsub('.pdf$','',pdf))
		}
		for (i in 1:nbech) {
			#if (i !=ref ) {
			#hist(diff[,i],nclass=100,main=colnames(tab.acp)[i],xlab=paste("logQ(",colnames(tab.acp)[i],")-logQ(",refSample,")"),xlim=c(-2,2))
			plot(tab.acp[,c(ref,i)])
		}
		if (!is.null(pdf)){
			dev.off()
		}
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqPlotDistribQlogCometDiff",sep=""))
	}
}




mcq.normalize<- function (object, method="percent") {

	return (mcq.normalize.by.sampleref(object, NULL, method));
}

mcq.normalize.by.sampleref<- function (object, refSample, method="median") {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		cat(paste("normalizing samples using the ",method," method\n",sep=""))
		if (method == "percent") {

			################"Normalisation par les pourcentages avant de faire les repetables
			fact=aggregate(object@peptides$area,list(object@peptides$msrun), FUN=sum)
			colnames(fact)=c("msrun","somme")
			fact$moy=mean(fact$somme)
			fact$fact=fact$moy/fact$somme
			fact$somme=NULL
			fact$moy=NULL
			object@peptides=merge(object@peptides, fact, by.x="msrun", by.y="msrun")

			object@peptides$areanorm=object@peptides$area*object@peptides$fact
			object@peptides$fact <- NULL
			object@peptides$lognorm=log10(object@peptides$areanorm)
		}
		if (method == "median") {
			################ normalisation ze
			if (refSample %in% object@peptides$msrun) {

			}
			else {
				stop(paste("the sample named ",refSample," is not in your \"", class(object),"\" object\n", sep=""))
			}

			nomref=refSample # choisir ici l'échantillon qui servira de référence


			tab.acp<- tapply (object@peptides$logarea, list(object@peptides$peptiz,object@peptides$msrun), FUN=sum)

			#tab.acp => rows = peptiz, cols = msrun, cell = sum of logarea

			ref=which(colnames(tab.acp)==nomref) # ref: numero de la colonne de ref dans tab.acp
			nbech=dim(tab.acp)[2] # 19
			nbpep=dim(tab.acp)[1] # 12697
			matref=matrix(rep(tab.acp[,ref],nbech),ncol=nbech)
			diff=tab.acp-matref

			## normalisation per se
			diffmed=apply(diff,2,median,na.rm=TRUE)
			diffmed=as.data.frame(diffmed)
#diffmed$msrun=rownames(diffmed)
			object@peptides=merge(object@peptides, diffmed, by.x="msrun", by.y="row.names")

			object@peptides$lognorm=object@peptides$logarea-object@peptides$diffmed
			object@peptides$areanorm=10^(object@peptides$lognorm)
		}
		return (object)
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqNormalizeBySampleref",sep=""))
	}
}

mcq.plot.normalization.effect <- function (object, pdf=NULL) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {
		if (is.null(pdf)){
			par(ask=TRUE)
		}
		else{
			pdf(pdf, title=gsub('.pdf$','',pdf))
		}
		if (is.null(object@peptides$lognorm)) {
			stop(paste("your \"", class(object),"\" was not normalized\n", sep=""))
		}
		boxplot(logarea~msrun, data=object@peptides,main="avant normalisation",cex.axis=0.5,las=2)
		boxplot(lognorm~msrun, data=object@peptides,main="après normalisation",cex.axis=0.5,las=2)
		if (!is.null(pdf)){
			dev.off()
		}
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqPlotNormalizationEffect",sep=""))
	}
}
