

mcq.pairwise.t.test = function (object, factor) {
	if (priv.mcq.is.protquant.object(object)) {

		newObject <- new ("mcq.pairwise.t.test", protval =  object@protval , metadata =  object@metadata, proteins = object@proteins,
				samples = object@samples, paramlist= list(),restest = list())

		newObject@paramlist$factor <- factor

		protlist <- unique(as.character(newObject@protval$protein))
		allprot <- newObject@protval[,c("msrun", "protein", "q")]
		allprot <- merge (allprot, newObject@metadata@metadata, by.x="msrun", by.y="row.names")

		nmodal <- length(levels(object@metadata@metadata[,factor]))

		secondl <- 1
		pairwisestr = c(rep("",1))
		i <- 0
		flist <- levels(object@metadata@metadata[,factor])
		for (ione in 1:(nmodal-1)){
			secondl <- secondl+1
			for (itwo in secondl:nmodal){
				i <- i+1
				pairwisestr[i] <- paste(flist[ione], flist[itwo], sep="--")
			}
		}
		ncomparisons <- length(pairwisestr)
		#print (pairwisestr)
		pval <- c(rep(NA, (ncomparisons *  length(protlist)) ))

		#names(pval) <- apply(expand.grid(protlist,pairwisestr),1,function(x) paste(x,collapse="__"))

		pair.result <- data.frame(ratio=pval, pval=pval, sderror=pval, proteins=rep(protlist, each=ncomparisons), pairs=rep(pairwisestr, length(protlist)))

		#rownames(pair.result) <- names(pval)
		rownames (pair.result) <- paste(pair.result$proteins,pair.result$pairs,sep="__")

		#print (pair.result)

		#print (names(newObject@restest$pval))
		#resultaov <- list()

		for (protid in protlist) {
			short.tab <- pair.result[pair.result$proteins == protid,]
			oneprot <- allprot[allprot$protein == protid,]
			test <- pairwise.t.test(oneprot$q, oneprot[,factor], p.adjust.method = "none",pool.sd = T, alternative = "two.sided")

			#resultaov[protid] <- list(aov(as.formula(paste("q~",factor,sep="")), data=oneprot))
			lm.summary <- summary(lm(as.formula(paste("q~",factor,sep="")), data=oneprot))
			#res2 <- summary(lm(Y~X))
			#res2$sigma

			aggdata <-aggregate(oneprot$q, by=list(oneprot[,factor]),	FUN=mean, na.rm=TRUE)

			#print (aggdata)

			count = table(oneprot[,factor], useNA = "no")

			#print (names(count)[2])

			#residual <- sqrt(anova(resultaov[[protid]])$"Mean Sq"[2])
			residual <- lm.summary$sigma


			for (pair in short.tab[,"pairs"]) {

				#print (pair)

				level.one <- strsplit(pair, "--")[[1]][1]

				#print (level.one)
				level.two <- strsplit(pair, "--")[[1]][2]

				multiple <- sqrt((1/count[level.one]) + (1/count[level.two]))

				#print (test$p.value)
				#print (level.two)
				rowid = paste(protid, pair,sep="__")
				#print (rowid)
				if ((level.two %in% rownames(test$p.value)) && (level.one %in% colnames(test$p.value))) {
					pair.result[rowid, "pval"] <- test$p.value[ level.two, level.one]
					pair.result[rowid, "sderror"] <- residual * multiple
					pair.result[rowid, "ratio"] <- (10^aggdata[aggdata$Group.1 == level.one, "x"])/(10^aggdata[aggdata$Group.1 == level.two, "x"])
				}
			}

			#print (test)
		}

		pair.result$padjust <- p.adjust(pair.result$pval,method="fdr")


		newObject@restest$pair.result <- pair.result
		#newObject@restest$listaov <- resultaov
		return (newObject)
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.pairwise.t.test",sep=""))
	}
}

mcq.select.pairwise.t.test.mindiff <-function (object, diff.log10=0.06) {
	if (class(object) == "mcq.pairwise.t.test") {

		nbprot <- length(unique(object@restest$pair.result$proteins))
		nbprot_pairs <- nrow(object@restest$pair.result)

		pairs <- object@restest$pair.result[abs(log10(object@restest$pair.result$ratio)) >= diff.log10 ,]
		object@restest$pair.result <- drop.levels(pairs)

		nbprot_pairs_after <- nrow(object@restest$pair.result)
		nbprot_after <- length(unique(object@restest$pair.result$proteins))

		cat (paste("dropping ", (nbprot-nbprot_after) ," proteins",sep=""))
		cat (paste("dropping ", (nbprot_pairs-nbprot_pairs_after) ," sample comparisons",sep=""))

		#object@restest$pair.result$padjust <- p.adjust(object@restest$pair.result$pval,method="fdr")

#"protein msrun count"
#cleaning object slots
		object@protval <- object@protval[object@protval$protein %in% object@restest$pair.result$proteins,]
		object@protval <- drop.levels(object@protval)

		msrunlist <- unique(object@protval$msrun)
		object@metadata@metadata$bidon <- rownames(object@metadata@metadata)
		object@metadata@metadata <- object@metadata@metadata[msrunlist,]
		object@metadata@metadata$bidon <- NULL
		object@metadata@metadata <- drop.levels(object@metadata@metadata)

#proteins="data.frame"
		object@proteins <- object@proteins[object@restest$pair.result$proteins,]
		object@proteins <- drop.levels(object@proteins)

#samples
		object@samples$bidonnage <-rownames(object@samples)
		object@samples <- object@samples[msrunlist,]
		object@samples$bidonnage <- NULL
		object@samples <- drop.levels(object@samples)

		return (object)
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.select.pairwise.t.test.mindiff",sep=""))
	}

}

mcq.select.pairwise.t.test.signif.fdr <-function (object, fdr) {
	if (class(object) == "mcq.pairwise.t.test") {

		object@restest$pair.result <- object@restest$pair.result[object@restest$pair.result$padjust <= fdr ,]
		object@restest$pair.result <- drop.levels(object@restest$pair.result)

#"protein msrun count"
#cleaning object slots
		object@protval <- object@protval[object@protval$protein %in% object@restest$pair.result$proteins,]
		object@protval <- drop.levels(object@protval)

		msrunlist <- unique(object@protval$msrun)
		object@metadata@metadata$bidon <- rownames(object@metadata@metadata)
		object@metadata@metadata <- object@metadata@metadata[msrunlist,]
		object@metadata@metadata$bidon <- NULL
		object@metadata@metadata <- drop.levels(object@metadata@metadata)

#proteins="data.frame"
		object@proteins <- object@proteins[object@restest$pair.result$proteins,]
		object@proteins <- drop.levels(object@proteins)

#samples
		object@samples$bidonnage <-rownames(object@samples)
		object@samples <- object@samples[msrunlist,]
		object@samples$bidonnage <- NULL
		object@samples <- drop.levels(object@samples)

		return (object)
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.select.pairwise.t.test.signif.fdr",sep=""))
	}

}


mcq.plot.pairwise.t.test = function (object,pdf=NULL) {

	tabprot <- object@protval
	listprot <- unique(object@protval$protein)
	factorName <- object@paramlist$factor

	cat(paste("The factor \"", factorName,"\" was used to select proteins significantly different\n", sep=""))

	cat(paste(length(listprot)," proteins significantly different between extrem levels of factor \"",factorName,  "\"\n", sep=""))

	if (is.null(pdf)){
		par(ask=TRUE)
	}
	else{
		pdf(pdf, title=gsub('.pdf$','',pdf))
	}

	tabprot <- merge(object@protval, object@metadata@metadata, by.x="msrun", by.y="row.names")

	for (protein_code in listprot) {
		tabcour=tabprot[tabprot$protein==protein_code,]
		protein_name <- object@proteins[protein_code, "accession"]
		if (is.na(protein_name)) {
			protein_name <- protein_code
		}
		title <- paste(protein_name, " (", factorName, ")", sep="")
		visuprot(protein_code,tabcour,tabcour$q,tabcour[,factorName], title=title)
	}



	if (!is.null(pdf)){
		dev.off()
	}

}
