

mcq.peakcounting = function(object) {
	if ((class(object) == "mcqProtPep") || (class(object) == "mcq.skyline")) {

		tab<- merge(object@peptides[,c("peptide", "msrun")],object@proteins,by="peptide")
		ni <- as.data.frame(table(list(tab$protein,tab$msrun)))
		colnames(ni)<-c("protein","msrun","count")
		#ni=merge(ni,unique(object@peptides[,c("msrun", "msrunfile")]),by="msrun")
		ni=drop.levels(ni)



		##### construction de la valeur de la protéine par somme des peptides.
# comme les données manquantes ont été remplacées, les sommes sont faites sur les mêmes peptides dans tous les échantillons.
# Ce sont les area et non des log qui doivent être sommés.
		tprot=ni
		colnames(tprot)=c("protein","msrun","q")
#récupération du descripteur
		prot.prot=unique(object@proteins[,c("protein","accession", "protein_description")])
		rownames(prot.prot) <- prot.prot$protein
		prot.prot$protein <- NULL

		tsamples = unique(object@peptides[,c("msrun","msrunfile")])
		rownames(tsamples) <- tsamples$msrun
		tsamples$msrun <- NULL


		#rename protein_description :
		colnames(prot.prot)[colnames(prot.prot) == "protein_description"] <- "descr"


		mcqCount <- new ("mcq.peakcounting", metadata = object@metadata, protval=tprot, proteins= prot.prot, samples= tsamples)
		return(mcqCount)
	}
	else {
		if (class(object) != "mcqData") {
			stop("input is not an mcqData or mcqProtPep object")
		}
		else {
			stop("mcqPeakCounting not implemented for mcqData")
		}
	}
	return (NULL)
}

mcq.peakcounting.kruskal = function (object, factorList) {
	if (class(object) == "mcq.peakcounting") {
		return (priv.mcq.anova(object, factorList, kruskal=T))
	}
	else {
		stop("input is not an mcq.peakcounting object")
	}
}

mcq.plot.peakcounting.kruskal = function (object,pdf=NULL) {
	if (class(object) == "mcq.peakcounting.kruskal") {
		priv.mcq.plot.anova(object,pdf)
	}
	else {
		stop("input is not an mcq.peakcounting.kruskal object")
	}

}

mcq.peakcounting.anova = function (object, factorList, Tukey=c()) {
	if (class(object) == "mcq.peakcounting") {
		return (priv.mcq.anova(object, factorList, kruskal=F, Tukey))
	}
	else {
		stop("input is not an mcq.peakcounting object")
	}
}

mcq.plot.peakcounting.anova = function (object,pdf=NULL) {
	if (class(object) == "mcq.peakcounting.anova") {
		priv.mcq.plot.anova(object,pdf)
	}
	else {
		stop("input is not an mcq.peakcounting.anova object")
	}

}


mcq.select.kruskal.signif <-function (object, pvalue) {
	if ((class(object) == "mcq.peakcounting.kruskal") || (class(object) == "mcq.spectralcounting.kruskal")) {

		return (priv.mcq.select.anova.signif(object, pvalue, object@paramlist$factorList[1]))
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.select.kruskal.signif",sep=""))
	}

}


