

read.mcqProtPep = function(protFilename, pepFilename, method.ni="max") {
	## Lecture des données peptides
	peptides=read.table(pepFilename, header=TRUE, sep="\t", dec=".", allowEscapes = FALSE, quote="")

	### Lecture données protéines et sauvegarde dans tab.RData
# # récupération du lien protéine-peptide
# #table contenantle lien prot<->desc et lien peptide<->prot
	proteins = read.table(protFilename, header=T,sep="\t",dec=".", allowEscapes = FALSE, quote="")


	peptide_col_names = c("group","msrun","msrunfile","mz" ,"rt"   ,        "maxintensity", "area"    ,     "rtbegin"    ,
			"rtend"      ,  "peptide"   ,   "isotope"    ,  "sequence"  ,   "z"         ,   "mods" )
	for (i in peptide_col_names) {
		if(i %in% colnames(peptides))
		{
		}
		else {
			stop(paste("ERROR in '",pepFilename,"' file : peptides dataframe does not contain expected columns. missing '", i, "' column name",sep=""))
			return (NULL)
		}
	}
	protein_col_names = c( "peptide"     ,        "protein",             "protein_description" )
	for (i in protein_col_names) {
		{
			if(i %in% colnames(proteins))
			{
			}
			else {
				stop(paste("ERROR in '",protFilename,"' file : proteins dataframe does not contain expected columns. missing '", i, "' column name",sep=""))
				return (NULL)
			}
		}
	}
	#new columns from MassChroQ with natural isotope enabled :
	#	ninumber	nirank	niratio
	if ("ninumber" %in% colnames(peptides)) {
		peptides$peptiz=as.factor(paste(peptides$peptide,peptides$z,sep='-'))
		peptides$peptiniid=as.character(paste(peptides$peptiz, peptides$ninumber, peptides$nirank,sep='-'))
		#peptides$peptiz=as.factor(paste(peptides$peptide,peptides$z, peptides$ninumber, peptides$nirank,sep='-'))

		if (method.ni == "max") {
			warning ("selecting the most theoretically abundant natural isotope among peptiz")
			#take only most intense ratio :
			tab_peptide_ni <- data.frame(peptiniid = unique(peptides$peptiniid))
			temp <- unique(peptides[,c("peptiniid","niratio", "peptiz")])

			tab_peptide_ni <- merge(tab_peptide_ni, temp, by.x="peptiniid", by.y="peptiniid")

			# use aggregate to create new data frame with the maxima
			df.agg <- aggregate(niratio ~ peptiz, tab_peptide_ni, max)
			tab_peptide_ni <- merge(df.agg, tab_peptide_ni)

			peptides <- peptides[peptides$peptiniid %in% tab_peptide_ni$peptiniid,]
		}
		if (method.ni == "mono") {
			warning ("selecting the monoisotope peptiz")
			peptides <- peptides[peptides$ninumber == 0,]
		}


	} else {
		peptides$peptiz=as.factor(paste(peptides$peptide,peptides$z,sep='-'))
	}
	peptides$logarea=log10(peptides$area)


	# parsing accession number
	proteins$protein_description <- str_trim(proteins$protein_description)
	proteins$accession <- word(proteins$protein_description)
	#whichTrunc <- length(grep(" ",proteins$protein_description))>0
	#proteins$accession[whichTrunc] <- substr(proteins$protein_description[whichTrunc],1,regexpr(" ",proteins$protein_description[whichTrunc])-1)
	#proteins$descr=proteins$protein_description
	#proteins$accession=proteins$protein_description

	#write.table(proteins,"/tmp/test.tsv", quote= FALSE,  sep="\t", dec=".",row=F)

	mcqProtPep <- new ("mcqProtPep", peptides = peptides	, proteins = proteins)
	rm (peptides)
	rm (proteins)
	return(mcq.drop(mcqProtPep,"area", 0))
}


