

mcq.plot.peptide.repeatability<- function (mcq,pdf=NULL) {
	if ((class(mcq) == "mcqProtPep") || (class(mcq) == "mcq.skyline")) {

		nbsample=length(levels(mcq@peptides$msrun))
		nbpeptiz=length(levels(mcq@peptides$peptiz))
		cat(paste("number of samples : ",nbsample,"\n", sep=""))
		cat(paste("nb peptiz : ",nbpeptiz,"\n", sep=""))

		ni = table(mcq@peptides$peptiz)

#juste pour se donner une idée de la distribution
		if (is.null(pdf)){
			par(ask=TRUE)
		}
		else{
			pdf(pdf, title=gsub('.pdf$','',pdf))
		}
		hist(ni,main="Number of samples in which a peptide was quantified",xlab="Number of samples",nclass=nbsample)
		if (!is.null(pdf)){
			dev.off()
		}
	}
	else {
		stop(paste("the class \"", class(mcq),"\" is not taken into account by mcqPlotPeptideRepeatability",sep=""))
	}
}


mcq.select.repeatable.peptides<- function (mcq, pct.max.mq) {
	if ((class(mcq) == "mcqProtPep") || (class(mcq) == "mcq.skyline")) {
		# comme on a déjà traité les variations qualitatives par peak counting, on va être stringeant maintenant pour l'analyse quantitative:
# admettons qu'on ne veut pas plus de 5% de données manquantes dans notre jeu de données:
		#pct.max.mq=0.05
#on veut donc garder les peptides présents au moins:
		nbsample=length(levels(mcq@peptides$msrun))
		nbpeptiz=length(levels(mcq@peptides$peptiz))
		ni <- table(mcq@peptides$peptiz)
		ok=ni>=floor(nbsample*(1-pct.max.mq))
		peptok=names(ok[ok])
		mcq@peptides=mcq@peptides[mcq@peptides$peptiz %in% peptok,]
		mcq@peptides=drop.levels(mcq@peptides)

		#cat(paste("nb of proteins 1 :",length(levels(object@proteins$protein)),"\n"))
		mcq@proteins <- mcq@proteins[mcq@proteins$peptide %in% unique(mcq@peptides$peptide),]
		mcq@proteins <- drop.levels(mcq@proteins)

		nbpeptiz_after=length(levels(mcq@peptides$peptiz))

		cat(paste((nbpeptiz - nbpeptiz_after)," peptiz dropped out of ",nbpeptiz,"\n"))
# remarque: en sélectionnant comme ça on exclut tous les peptiz qui auraient été spécifiquement absents dans un ou plusieurs traitements.
# ces peptiz ont déjà été reprérés par peak counting, Mais il pourrait être intéressant quand même d'analyser leur variation quantitative dans les traitments où ils sont présents.
# il faudra doinc traiter ces peptides à part.
		return (mcq)

	}
	else {
		stop(paste("the class \"", class(mcq),"\" is not taken into account by mcqSelectRepeatablePeptides",sep=""))
	}
}
