

read.mcq.spectralcounting = function(comparspectraFile) {
	#scounting = read.table(comparspectraFile,header=T,sep="\t",check.names=FALSE, dec=".", allowEscapes = FALSE, quote="")
	scounting = read.delim(comparspectraFile,allowEscapes = FALSE, quote="",check.names=F)

	# parsing accession number
	scounting[,"Top Protein Description"] <- str_trim(scounting[,"Top Protein Description"])
	scounting$protein <- as.factor(word(scounting[,"Top Protein Description"]))


#récupération du descripteur
	prot.prot=unique(scounting[,c("protein", "Top Protein Description")])
	prot.prot$accession <- prot.prot$protein
	rownames(prot.prot) <- prot.prot$protein
	prot.prot$protein <- NULL

	#rename protein_description :
	colnames(prot.prot)[colnames(prot.prot) == "Top Protein Description"] <- "descr"


	samples=colnames(scounting)[7:length(scounting)-1]
	scounting=melt(scounting, id.vars = "protein", measure.vars = samples)
	colnames(scounting)=c("protein","msrunfile","count")

	##### construction de la valeur de la protéine par somme des peptides.
# comme les données manquantes ont été remplacées, les sommes sont faites sur les mêmes peptides dans tous les échantillons.
# Ce sont les area et non des log qui doivent être sommés.
	tprot=scounting
	colnames(tprot)=c("protein","msrun","q")

	#get samples information
	scounting$msrun <- scounting$msrunfile
	tsamples = unique(scounting[,c("msrun","msrunfile")])
	rownames(tsamples) <- tsamples$msrun
	tsamples$msrun <- NULL





	mcqCount <- new ("mcq.spectralcounting", protval=tprot, proteins= prot.prot, samples= tsamples)
	return(mcqCount)

}

mcq.spectralcounting.kruskal = function (object, factorList) {
	if (class(object) == "mcq.spectralcounting") {
		return (priv.mcq.anova(object, factorList, kruskal=T))
	}
	else {
		stop("input is not an mcq.spectralcounting object")
	}
}

mcq.plot.spectralcounting.kruskal = function (object,pdf=NULL) {
	if (class(object) == "mcq.spectralcounting.kruskal") {
		priv.mcq.plot.anova(object,pdf)
	}
	else {
		stop("input is not an mcq.spectralcounting.kruskal object")
	}

}

mcq.spectralcounting.anova = function (object, factorList) {
	if (class(object) == "mcq.spectralcounting") {
		return (priv.mcq.anova(object, factorList, kruskal=F))
	}
	else {
		stop("input is not an mcq.spectralcounting object")
	}
}

mcq.plot.spectralcounting.anova = function (object,pdf=NULL) {
	if (class(object) == "mcq.spectralcounting.anova") {
		priv.mcq.plot.anova(object,pdf)
	}
	else {
		stop("input is not an mcq.spectralcounting.anova object")
	}

}

