

priv.summary.protpep.object = function (object) {
	#nb de protéines (length(levels(protein)), nb de peptiz (length(levels(peptiz))), nb de peptides 	(length(levels(peptiz))),
	######## nb de samples (length(levels(msrun)))
	#		print (summary (object@proteins))
	nbxics <- length(object@peptides$peptiz)
	nbpeptiz <- length(unique(object@peptides$peptiz))

	cat (paste("number of proteins : ", length(unique(object@proteins$protein)),"\n", sep=""));
	cat (paste("number of XICs : ", nbxics,"\n", sep=""));
	cat (paste("number of peptiz : ", nbpeptiz,"\n", sep=""));
	cat (paste("number of peptides : ", length(unique(object@peptides$peptide)),"\n", sep=""));
	cat (paste("number of samples : ", length(unique(object@peptides$msrun)),"\n", sep=""));
	if("lognorm" %in% colnames(object@nona)) {
		nbimpxics <- length(object@nona$peptiz)
		cat (paste("number of imputated XIC values : ", (nbimpxics - nbxics),"\n", sep=""));
	}

#pourcentage de données manquantes :
	compar = mcq.get.compar(object);
	nb_na = sum(is.na(compar))
	cat (paste("number of NA values : ", nb_na,"\n", sep=""));
	cat (paste("% of NA values : ", 100* nb_na/(nrow(compar) * ncol(compar)),"\n", sep=""));

}

setMethod('summary', "mcqProtPep",
		function(object, ...) {
			priv.summary.protpep.object(object)
		}
)


setMethod('summary', "mcq.skyline",
		function(object, ...) {
			priv.summary.protpep.object(object)
		}
)

priv.summary.protquant.object = function (object) {
	cat (paste("number of proteins : ", length(rownames(object@proteins)),"\n", sep=""));
	cat (paste("number of samples : ", length(rownames(object@samples)),"\n", sep=""));


#pourcentage de données manquantes :
	compar = mcq.get.compar(object);
	nb_na = sum(is.na(compar))
	cat (paste("number of NA values : ", nb_na,"\n", sep=""));
	cat (paste("% of NA values : ", 100* nb_na/(nrow(compar) * ncol(compar)),"\n", sep=""));

}

setMethod('summary', "mcq.protquantity",
		function(object, ...) {
			priv.summary.protquant.object(object)
		}
)

setMethod('summary', "mcq.peakcounting",
		function(object, ...) {
			priv.summary.protquant.object(object)
		}
)

setMethod('summary', "mcq.spectralcounting",
		function(object, ...) {
			priv.summary.protquant.object(object)
		}
)

setMethod('summary', "mcqData",
		function(object, ...) {
			#code for class_1 summary here...
			objectList <- c("samples", "groups","proteins","peptidesmh", "observedin","quantify", "quantipeptides")
			coln <- c ("type", "description", "count")
			#rown <- c (names(object))

			typelist <- c(class(object@samples), class(object@groups), class(object@proteins), class(object@peptidesmh),class(object@observedin), class(object@quantify), class(object@quantipeptides))
			desc <- c("MS samples", "Groups of MS samples","Identified proteins","Identified peptides (unique peptide-mh)", "MS/MS peptide identifications","Quantifications on groups", "peptides quantifications")
			countV <- c(length(object@samples)[[1]], length(object@groups)[[1]], length(object@proteins)[[1]], nrow(object@peptidesmh)[[1]],nrow(object@observedin)[[1]], nrow(object@quantify)[[1]], nrow(object@quantipeptides)[[1]])
			df <- data.frame(typelist, desc, countV)
			rownames (df) <- objectList
			colnames (df) <- coln
			print (df)
		}
)

setMethod('summary', "mcqMetadata",
		function(object, ...) {
			print (summary (object@metadata))
		}
)

setMethod('summary', "mcqPeptidePCA",
		function(object, ...) {

			cat (paste("number of XICs : ", length(object@peptides$peptiz),"\n", sep=""));
			cat (paste("number of peptiz : ", length(unique(object@peptides$peptiz)),"\n", sep=""));
			cat (paste("number of peptides : ", length(unique(object@peptides$peptide)),"\n", sep=""));
			cat (paste("number of samples : ", length(unique(object@peptides$msrun)),"\n", sep=""));
		}
)


setMethod('summary', "mcq.protlist",
		function(object, ...) {

			cat (paste("number of proteins : ", length(object@proteins),"\n", sep=""));
		}
)