library('MassChroqR')

setwd ('/tmp')

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- read.mcqProtPep('/gorgone/pappso/formation/Decembre2014/XIC_result_prot.tsv', '/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv')

	# import des métadata
	metadata <- read.mcq.metadata.ods('/gorgone/pappso/formation/Decembre2014/metadata.ods')

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}


# Statistiques exploratoires : ACP sur les peptides (peptiz / échantillons)
cat ('mcq.peptide.pca(protPep)\n')
	peptidepca <- mcq.peptide.pca(protPep)

# visualisation des axes de l'ACP
cat ('mcq.plot.peptide.pca(peptidepca, colors="extraction")\n')
	mcq.plot.peptide.pca(peptidepca, colors="extraction",pdf="objetssparam_acp_1prm.pdf")
cat ('mcq.plot.peptide.pca(peptidepca)\n')
	mcq.plot.peptide.pca(peptidepca,pdf="objetssparam_acp_1prm_nocolor.pdf")

# Statistiques exploratoires : ACP sur les peptides (peptiz / extraction-rep, colonnes du fichiers metadata)
cat ('mcq.peptide.pca(protPep,c("extraction","rep"))\n')
	peptidepca <- mcq.peptide.pca(protPep, c("extraction","rep"))
# visualisation des axes de l'ACP
cat ('mcq.plot.peptide.pca(peptidepca, colors="extraction")\n')
	mcq.plot.peptide.pca(peptidepca, colors="extraction",pdf="objet2param_acp_1prm.pdf")

# Statistiques exploratoires : ACP sur les peptides (peptiz / extraction-rep, colonnes du fichiers metadata)
cat ('mcq.peptide.pca(protPep,c("extraction"))\n')
	peptidepca <- mcq.peptide.pca(protPep, c("extraction"))
# visualisation des axes de l'ACP
cat ('mcq.plot.peptide.pca(peptidepca, colors="extraction")\n')
	mcq.plot.peptide.pca(peptidepca, colors="extraction",pdf="objet1param_acp_1prm.pdf")

# Statistiques exploratoires : ACP sur les peptides (peptiz / extraction-rep, colonnes du fichiers metadata)
cat ('mcq.peptide.pca(protPep,c("extraction"))\n')
	peptidepca <- mcq.peptide.pca(protPep, c("extraction"))
# visualisation des axes de l'ACP
cat ('mcq.plot.peptide.pca(peptidepca)\n')
	mcq.plot.peptide.pca(peptidepca,pdf="objet1param_acp_0prm.pdf")
