# chargement du paquet
	library('MassChroqR')
#
	setwd ('/tmp')

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- read.mcqProtPep('/gorgone/pappso/formation/Decembre2014/XIC_result_prot.tsv', '/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv')

	# import des métadata
	metadata <- read.mcq.metadata.ods('/gorgone/pappso/formation/Decembre2014/metadata.ods')

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

################################################################################
################################# Analyse par 'Peakcounting' (Variations qualitatives) 
################################################################################

# comptage du nombre de 'peak' (= peptide-charge) par protéine dans chaque échantillon
pkcount <- mcq.peakcounting(protPep)

#str(pkcount)

#test ANOVA de pkcount à 1 facteur
anova <- mcq.anova(pkcount, 'extraction')
#str(anova)

# on calcul toutes les padjust
pkcount.signif.fdr <- mcq.select.protlist.signif(anova, method="BH")

str(pkcount.signif.fdr)

# on sélectionne les protéines significatives (donne seuil alpha et methode fdr)
pkcount.signif.fdr <- mcq.select.protlist.signif(anova, 0.05, "BH")

str(pkcount.signif.fdr)

# on récupère la liste des protéines de l'anova
#protlist <- mcq.get.protlist(anova)
#str(protlist)
#######################################################

#ANOVA à 2 facteurs (ne fonctionne pas pour l'instant)
#anova <- mcq.anova(pkcount, c('extraction','rep'))
#str(anova)

#######################################################
# test kruskal de pkcount sur totalité
pkcount.kruskal = mcq.peakcounting.kruskal(pkcount,'extraction')

str(pkcount.kruskal)

# on calcul toutes les padjust
pkcount.kruskal.signif.fdr <- mcq.select.protlist.signif(pkcount.kruskal, method="BH")




