library('MassChroqR')

setwd ('/tmp')

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- read.mcqProtPep('/gorgone/pappso/formation/Decembre2014/XIC_result_prot.tsv', '/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv')

	# import des métadata
	metadata <- read.mcq.metadata.ods('/gorgone/pappso/formation/Decembre2014/metadata.ods')

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

if (file.exists("protq.RData")) {
	load("protq.RData")
} else {
	qprot <- mcq.protquantity(protPep)
	save(qprot, file="protq.RData")
}

#cv = mcq.cv(protPep, "je sais pas");

cv = mcq.get.cv(protPep, "rep");
summary(cv)

cat ("*********************************************\n")
cat (" mcq.get.cv on protpep OK\n")
cat ("*********************************************\n")

#cv = mcq.cv(qprot, "je sais pas");

cv = mcq.get.cv(qprot, "rep");
summary(cv)

cat ("*********************************************\n")
cat (" mcq.get.cv on prot OK\n")
cat ("*********************************************\n")



