library('MassChroqR')

setwd ('/tmp')


if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- read.mcqProtPep('/gorgone/pappso/formation/Decembre2014/XIC_result_prot.tsv', '/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv')

	# import des métadata
	metadata <- read.mcq.metadata.ods('/gorgone/pappso/formation/Decembre2014/metadata.ods')

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

if (file.exists("protq.RData")) {
	load("protq.RData")
} else {
	qprot <- mcq.protquantity(protPep)
	save(qprot, file="protq.RData")
}

if (file.exists("ttest.RData")) {
	load("ttest.RData")
} else {
	ttest <- mcq.pairwise.t.test(qprot, "extraction")
	save(ttest, file="ttest.RData")
}

ratio = mcq.get.ratio(ttest, "tca1", "teal");
summary(ratio)

cat ("*********************************************\n")
cat (" mcq.get.ratio OK\n")
cat ("*********************************************\n")
