library('MassChroqR')

setwd ('/tmp')

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- read.mcqProtPep('/gorgone/pappso/formation/Decembre2014/XIC_result_prot.tsv', '/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv')

	# import des métadata
	metadata <- read.mcq.metadata.ods('/gorgone/pappso/formation/Decembre2014/metadata.ods')

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}



# Suppression des peptides communs à plusieurs protéines
protPep <- mcq.drop.shared.peptides(protPep)

summary(protPep)
# b /Si le facteur "traitement" présente moins de 3 modalités : on ne garde que les protéines quantifiées par au moins 2 peptides
protPep <- mcq.select.2pepbyprot(protPep)

summary(protPep)

protPep <- mcq.select.2pepbyprot(protPep, 'rep')

summary(protPep)

cat ("*********************************************\n")
cat (" mcq.select.2pepbyprot(protPep) OK\n")
cat ("*********************************************\n")



