
# chargement du paquet
library('MassChroqR')
#	library('gdata')

# changement du répertoire de travail (remplacer /chemin/vers/repertoire_de_travail par votre arborescence)
setwd ('/tmp')
getwd()


if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- read.mcqProtPep('/gorgone/pappso/formation/Decembre2014/XIC_result_prot.tsv', '/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv')

	# import des métadata
	metadata <- read.mcq.metadata.ods('/gorgone/pappso/formation/Decembre2014/metadata.ods')

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

if (file.exists("protq.RData")) {
	load("protq.RData")
} else {
	qprot <- mcq.protquantity(protPep)
	save(qprot, file="protq.RData")
}


ttest <- mcq.pairwise.t.test(qprot, "extraction")

protselect.nona <- mcq.get.protlist(ttest, fdr=0.05)

head(protselect.nona@proteins)

protselect.nona <- mcq.get.protlist(ttest, fdr=0.05, pair=c("1","2"))

head(protselect.nona@proteins)
