library('MassChroqR')

setwd ('/tmp')

if (file.exists("protpep.RData")) {
	load("protpep.RData")
} else {
	protPep <- read.mcqProtPep('/gorgone/pappso/formation/Decembre2014/XIC_result_prot.tsv', '/gorgone/pappso/formation/Decembre2014/XIC_result_pep.tsv')

	# import des métadata
	metadata <- read.mcq.metadata.ods('/gorgone/pappso/formation/Decembre2014/metadata.ods')

	# Ajout des métadata à l'objet protPep
	protPep <- mcq.merge.metadata(protPep, metadata)
	save(protPep, file="protpep.RData")
}

if (file.exists("protq.RData")) {
	load("protq.RData")
} else {
	qprot <- mcq.protquantity(protPep)
	save(qprot, file="protq.RData")
}


if (file.exists("ttest.RData")) {
	load("ttest.RData")
} else {
	ttest <- mcq.pairwise.t.test(qprot, "extraction")
	save(ttest, file="ttest.RData")
}

plist = mcq.protlist(c("GRMZM2G139643_P01 NP_001131946 hypothetical protein LOC100193339 seq=translation; coord=4:229898346..229903473:1; parent_transcript=GRMZM2G139643_T01; parent_gene=GRMZM2G139643",
				"GRMZM2G140116_P01 NP_001131498 hypothetical protein LOC100192835 seq=translation; coord=2:197230836..197232295:1; parent_transcript=GRMZM2G140116_T01; parent_gene=GRMZM2G140116"
				, "GRMZM2G004111_P01 B6TW91 Putative uncharacterized protein seq=translation; coord=8:169891088..169891851:-1; parent_transcript=GRMZM2G004111_T01; parent_gene=GRMZM2G004111"
				,
				"GRMZM2G001898_P01 NP_001142146 hypothetical protein LOC100274311 seq=translation; coord=7:13844415..13850805:1; parent_transcript=GRMZM2G001898_T01; parent_gene=GRMZM2G001898"
		))

protPep.minus <- mcq.select.protlist(protPep, plist)
summary(protPep.minus)
mcq.write.compar.tsv(protPep.minus, 'peptide_minus.tsv')


chicken = mcq.protlist(c("sp|P01012|OVAL_CHICK"))
protPep_chicken <- mcq.select.protlist(protPep, chicken)
summary(protPep_chicken)
mcq.write.compar.tsv(protPep_chicken, 'peptide_chicken.tsv')

# test de mcq.grep.protlist :

protlist = mcq.get.protlist(protPep)
protlist = mcq.grep.protlist(protlist, "HORSE")


print ("test select protlist on T test")
protselect.nona <- mcq.get.protlist(ttest, fdr=0.05)
#str(protselect.nona)
#head (protselect.nona)

print ("length(plist@proteins)")
length(plist@proteins)
print ("length(plist)")
length(plist)
#length(protselect.nona)
#length (plist)
