
priv.mcq.plot.peak.per.samples = function (object, filename,pdf=NULL) {
# pour voir si on a besoin de normaliser:
	ni.tot.p.ech=aggregate(object@protval$q,list(object@protval$msrun),FUN=sum)
	if (is.null(pdf)){
		par(ask=TRUE)
	}
	else{
		pdf(pdf, title=gsub('.pdf$','',pdf))
	}
	sdni=sd(ni.tot.p.ech$x)
	mni=mean(ni.tot.p.ech$x)
	barplot(ni.tot.p.ech$x,main="Peak per sample",names=ni.tot.p.ech$Group.1,las=2,cex.names=0.7)
	mtext(paste("sd/mean : ",round(sdni/mni,6),sep=""),side=3)
	if (!is.null(pdf)){
		dev.off()
	}
}

mcq.plot.proteins = function (object,pdf=NULL, factor=NULL, protlist=NULL) {
	if (priv.mcq.is.trully.anova.object(object)) {
		if (is.null(object@resultanov)) {
			stop("there is no anova results in your object")
		}
		if (is.null(object@paramlist$factorsignif)) {
			stop("mcq.plot.proteins only works after mcq.select.signif")
		}
		factorName <- object@paramlist$factorsignif

		cat(paste("The factor \"", factorName,"\" was used to select proteins significantly different\n", sep=""))
	}
	else if (priv.mcq.is.protquant.object(object)) {
		if (!factor %in% colnames(object@metadata@metadata)) {
			stop(paste("the factor '",factor,"' does not exists ", " choose one factor to display data among :", paste(colnames(object@metadata@metadata), collapse=", "),sep=""))
		}
		if (is.null(factor)) {
			# stop
			stop(paste("the 'factor' parameter is not defined. ", "choose one factor to display data among :", paste(colnames(object@metadata@metadata), collapse=", "),sep=""))
		}
		factorName <- factor
		# test if factor exists
	} else if ((class(object) == "mcq.peakcounting.kruskal") || (class(object) == "mcq.spectralcounting.kruskal")) {
		factorName <- factor
		if (is.null(factor)) {
			if (is.null(object@paramlist$factorsignif)) {
				stop(paste("the 'factor' parameter is not defined. ", "choose one factor to display data among :", paste(colnames(object@metadata@metadata), collapse=", "),sep=""))
			}
			factorName <- object@paramlist$factorsignif
		}

		cat(paste("The factor \"", factorName,"\" was used to select proteins significantly different\n", sep=""))
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcq.plot.proteins",sep=""))
	}
	if (is.null(protlist)) {
		protlist <- mcq.get.protlist(object)
	}

	if (is.null(pdf)){
		par(ask=TRUE)
	}
	else{
		pdf(pdf, title=gsub('.pdf$','',pdf))
	}

	tabprot <- merge(object@protval, object@metadata@metadata, by.x="msrun", by.y="row.names")
	tabprot <- merge(tabprot, object@proteins, by.x="protein", by.y="row.names")

	nbprot <- 0
	for (accession in names(protlist@proteins)) {

		tabcour <- tabprot[tabprot$accession==accession,]
		if(nrow(tabcour)==0) {

		}
		else {
			#protein_name <- listprot@proteins[accession]
			protein_name <- accession
			title <- paste(protein_name, " (", factorName, ")", sep="")

			if (dim(tabcour)[1]>0) {
				par(mar=c(5,4,0,2)+0.1)
				par(oma=c(1,1,7,1))
				boxplot(as.formula(paste("q~",factorName,sep="")), data=tabcour)
				mtext(title,side=3, line=5.0, adj=0.5, cex=1.6,outer=TRUE)
			}
			nbprot <- nbprot +1
		}
	}
	cat(paste(nbprot, " protein(s) plotted\n", sep=""))



	if (!is.null(pdf)){
		dev.off()
	}

}

mcq.plot.peak.per.samples = function (object, filename,pdf=NULL) {

	if ((class(object) == "mcq.peakcounting")|| (class(object) == "mcq.spectralcounting")) {
		priv.mcq.plot.peak.per.samples(object, filename,pdf)
	}
	else {
		stop("input is not an mcq.spectralcounting or mcq.peakcounting object")
	}
}
