
mcq.protein.pca = function (object, flist=NULL) {
	if (class(object) == "mcq.protquantity") {


		############################ ACP sur protéines présentes partout (sont toutes présentes partout maintenant).

		tsamples = object@samples

		#tproteins = unique(object@proteins[,c("protein","peptide", "accession", "protein_description")])
		tproteins=object@proteins
		rownames(tproteins) <- tproteins$protein



		tacp= mcq.get.compar(object, flist)


		if (length(rownames(tacp)) < 3) {
			stop(paste("Too few proteins (",length(rownames(tacp)),") to perform PCA", sep=""))
		}
		if (length(colnames(tacp)) < 3) {
			stop(paste("Too few dimensions (",length(colnames(tacp)),") to perform PCA", sep=""))
		}


		acpnf <- length(colnames(tacp))-1
		if (acpnf > 5) {
			#on garde 5 axes... max
			acpnf <- 5
		}

		tacp <- na.omit(tacp)
		# cleaning dataframes after na.omit
		proteinList <- rownames(tacp)
		#print (head(peptizList))
		#print (head(tpeptides$peptiz))

		tproteins <- tproteins[tproteins$protein %in% proteinList,]
		tproteins <- drop.levels(tproteins)



		newObject <- new ("mcqProtPCA", metadata = object@metadata	, proteins = tproteins, samples = tsamples, pca = list())
		newObject@pca$dudi <- dudi.pca(t(tacp),center = T, scale = T, scannf = F, nf = acpnf) # on garde 5 axes
		newObject@pca$factorList <- flist
		newObject@pca$nf <- acpnf

		newObject@pca$qname <- "q"


		return (newObject)

	}
	else {
		stop("input is not an mcq.protquantity object")
	}
}


mcq.plot.protein.pca = function (object, colors=NULL, pdf=NULL) {
	if (class(object) == "mcqProtPCA") {
		privMcqPlotPCA(object, colors, pdf)
	}
	else {
		stop("input is not an mcqProtPCA object")
	}
}
